silent=0
for arg in "$@"
do
    case "${arg}" in
        -s | --silent )      silent=1 ;;
    esac
done

 # INTEL_LICENSE_FILE:
if [ -n "/opt/intel/licenses:/root/intel/licenses" ]; then
    if [ -n "${INTEL_LICENSE_FILE}" ]; then
        INTEL_LICENSE_FILE="/opt/intel/licenses:/root/intel/licenses:${INTEL_LICENSE_FILE}"
    else
        INTEL_LICENSE_FILE="/opt/intel/licenses:/root/intel/licenses"
    fi
    export INTEL_LICENSE_FILE
fi

 # VT_ROOT:
VT_ROOT="/opt/ohpc/pub/itac/9.1.2.024"
export VT_ROOT

 # VT_ARCH:
VT_ARCH=intel64
export VT_ARCH

 # Temporary internal variable VT_ROOT_ARCH:
if [ -z "${VT_ARCH}" ]; then
    VT_ROOT_ARCH="${VT_ROOT}"
else
    VT_ROOT_ARCH="${VT_ROOT}/${VT_ARCH}"
fi

 # Check:
if [ ! -d "${VT_ROOT_ARCH}/lib" ]; then
    # if only Intel(R) Trace Analyzer is installed:
    if [ -d "${VT_ROOT_ARCH}/bin" ]; then
         # PATH:
        if [ -n "${PATH}" ]; then
            PATH="${VT_ROOT_ARCH}/bin:${PATH}"
        else
            PATH="${VT_ROOT_ARCH}/bin"
        fi
        export PATH
        unset VT_ROOT VT_ARCH VT_ROOT_ARCH
    return 0
    fi
    if [ $silent -eq 0 ]; then
        echo "*** itacvars.sh: invalid VT_ROOT '${VT_ROOT}'" >&2
    fi
    unset VT_ROOT VT_ARCH VT_ROOT_ARCH
    return 1
fi

 # VT_LIB_DIR, VT_SLIB_DIR, VT_ADD_LIBS:
           VT_MPI="impi4"
           VT_LIB_DIR="${VT_ROOT_ARCH}/lib"
           VT_SLIB_DIR="${VT_ROOT_ARCH}/slib"
           VT_MIC_SLIB_DIR="${VT_ROOT}/mic/slib"
           VT_ADD_LIBS="-ldwarf -lelf -lvtunwind -lnsl -lm -ldl -lpthread"
export VT_MPI VT_LIB_DIR VT_SLIB_DIR VT_ADD_LIBS

 # Check:
if [ ! -d "${VT_LIB_DIR}" ] || [ ! -d "${VT_SLIB_DIR}" ]; then
    if [ $silent -eq 0 ]; then
        echo "*** itacvars.sh: Library folders were not found. Installation may be incomplete." >&2
    fi
    unset VT_ROOT VT_ARCH VT_ROOT_ARCH VT_MPI VT_LIB_DIR VT_SLIB_DIR VT_ADD_LIBS
    return 1
fi

 # LD_LIBRARY_PATH:
if [ -n "${LD_LIBRARY_PATH}" ]; then
    LD_LIBRARY_PATH="${VT_SLIB_DIR}:${LD_LIBRARY_PATH}"
else
    LD_LIBRARY_PATH="${VT_SLIB_DIR}"
fi
if [ -d "${VT_MIC_SLIB_DIR}" ]; then
    LD_LIBRARY_PATH="${VT_MIC_SLIB_DIR}:${LD_LIBRARY_PATH}"
fi
export LD_LIBRARY_PATH

 # PATH:
if [ -n "${PATH}" ]; then
    PATH="${VT_ROOT_ARCH}/bin:${PATH}"
else
    PATH="${VT_ROOT_ARCH}/bin"
fi
export PATH

 # MANPATH:
if [ -n "${MANPATH}" ]; then
    MANPATH="${VT_ROOT}/man:${MANPATH}"
else
    MANPATH="${VT_ROOT}/man":$(manpath)
fi
export MANPATH

 # CLASSPATH:
if [ -n "${CLASSPATH}" ]; then
    CLASSPATH="${VT_LIB_DIR}:${CLASSPATH}"
else
    CLASSPATH="${VT_LIB_DIR}"
fi
export CLASSPATH

 # Unset temporary variables
unset VT_ROOT_ARCH

# call mpsvars.sh as well with default settings i.e. nopapi
if [ $silent -eq 0 ]; then
    source ${VT_ROOT}/${VT_ARCH}/bin/mpsvars.sh --tooldir=${VT_ROOT}
else
    source ${VT_ROOT}/${VT_ARCH}/bin/mpsvars.sh --silent --tooldir=${VT_ROOT}
fi
