!***********************************************************************
!
! Intel(R) Trace Collector Library.
!
! Copyright(C) 1997-2015 Intel Corporation.
! All Rights Reserved.
! 
! The source code contained or described herein and all documents
! related to the source code ("Material") are owned by Intel
! Corporation or its suppliers or licensors. Title to the Material
! remains with Intel Corporation or its suppliers and licensors. The
! Material contains trade secrets and proprietary and confidential
! information of Intel or its suppliers and licensors. The Material
! is protected by worldwide copyright and trade secret laws and
! treaty provisions. No part of the Material may be used, copied,
! reproduced, modified, published, uploaded, posted, transmitted,
! distributed, or disclosed in any way without Intel's prior express
! written permission.
! 
! No license under any patent, copyright, trade secret or other
! intellectual property right is granted to or conferred upon you by
! disclosure or delivery of the Materials, either expressly, by
! implication, inducement, estoppel or otherwise. Any license under
! such intellectual property rights must be express and approved by
! Intel in writing.
! 
!***********************************************************************

!***********************************************************************
!
! @name Intel(R) Trace Collector API
!
!***********************************************************************

!-->  Version constant
      INTEGER VT_VERSION
      PARAMETER (VT_VERSION=7000)
      INTEGER VT_VERSION_COMPATIBILITY
      PARAMETER (VT_VERSION_COMPATIBILITY=2090)

!-->  Max user-defined symbol code
      INTEGER VT_MAXCODE
      PARAMETER (VT_MAXCODE=32768)

!-->  No State
      INTEGER VT_NOSTATE
      PARAMETER (VT_NOSTATE=-1)

!-->  No Class
      INTEGER VT_NOCLASS
      PARAMETER (VT_NOCLASS=0)

!-->  No SCL
      INTEGER VT_NOSCL
      PARAMETER (VT_NOSCL=-2147483645)

!-->  ITC error codes
      INTEGER VT_OK
      INTEGER VT_ERR_NOLICENSE
      INTEGER VT_ERR_NOTIMPLEMENTED
      INTEGER VT_ERR_NOTINITIALIZED
      INTEGER VT_ERR_BADREQUEST
      INTEGER VT_ERR_BADSYMBOLID
      INTEGER VT_ERR_BADSCLID
      INTEGER VT_ERR_BADSCL
      INTEGER VT_ERR_BADFORMAT
      INTEGER VT_ERR_BADKIND
      INTEGER VT_ERR_NOMEMORY
      INTEGER VT_ERR_BADFILE
      INTEGER VT_ERR_FLUSH
      INTEGER VT_ERR_BADARG
      INTEGER VT_ERR_NOTHREADS
      INTEGER VT_ERR_BADINDEX
      INTEGER VT_ERR_COMM
      INTEGER VT_ERR_INVT
      PARAMETER( VT_OK=0 )
      PARAMETER( VT_ERR_NOLICENSE=-1 )
      PARAMETER( VT_ERR_NOTIMPLEMENTED=-2 )
      PARAMETER( VT_ERR_NOTINITIALIZED=-3 )
      PARAMETER( VT_ERR_BADREQUEST=-4 )
      PARAMETER( VT_ERR_BADSYMBOLID=-5 )
      PARAMETER( VT_ERR_BADSCLID=-6 )
      PARAMETER( VT_ERR_BADSCL=-7 )
      PARAMETER( VT_ERR_BADFORMAT=-8 )
      PARAMETER( VT_ERR_BADKIND=-9 )
      PARAMETER( VT_ERR_NOMEMORY=-10 )
      PARAMETER( VT_ERR_BADFILE=-11 )
      PARAMETER( VT_ERR_FLUSH=-12 )
      PARAMETER( VT_ERR_BADARG=-13 )
      PARAMETER( VT_ERR_NOTHREADS=-14 )
      PARAMETER( VT_ERR_BADINDEX=-15 )
      PARAMETER( VT_ERR_COMM=-16 )
      PARAMETER( VT_ERR_INVT=-17 )

!-->  predefined communicators
      INTEGER VT_COMM_INVALID
      INTEGER VT_COMM_WORLD
      INTEGER VT_COMM_SELF
      PARAMETER( VT_COMM_INVALID=0 )
      PARAMETER( VT_COMM_WORLD=1 )
      PARAMETER( VT_COMM_SELF=2 )

!-->  operation ids
      INTEGER VT_OP_INVALID
      INTEGER VT_OP_BARRIER
      INTEGER VT_OP_IBARRIER
      INTEGER VT_OP_BCAST
      INTEGER VT_OP_IBCAST
      INTEGER VT_OP_GATHER
      INTEGER VT_OP_IGATHER
      INTEGER VT_OP_GATHERV
      INTEGER VT_OP_IGATHERV
      INTEGER VT_OP_SCATTER
      INTEGER VT_OP_ISCATTER
      INTEGER VT_OP_SCATTERV
      INTEGER VT_OP_ISCATTERV
      INTEGER VT_OP_ALLGATHER
      INTEGER VT_OP_IALLGATHER
      INTEGER VT_OP_ALLGATHERV
      INTEGER VT_OP_IALLGATHERV
      INTEGER VT_OP_ALLTOALL
      INTEGER VT_OP_IALLTOALL
      INTEGER VT_OP_ALLTOALLV
      INTEGER VT_OP_IALLTOALLV
      INTEGER VT_OP_ALLTOALLW
      INTEGER VT_OP_IALLTOALLW
      INTEGER VT_OP_NEIGHBOR_ALLGATHER
      INTEGER VT_OP_INEIGHBOR_ALLGATHER
      INTEGER VT_OP_NEIGHBOR_ALLGATHERV
      INTEGER VT_OP_INEIGHBOR_ALLGATHERV
      INTEGER VT_OP_NEIGHBOR_ALLTOALL
      INTEGER VT_OP_INEIGHBOR_ALLTOALL
      INTEGER VT_OP_NEIGHBOR_ALLTOALLV
      INTEGER VT_OP_INEIGHBOR_ALLTOALLV
      INTEGER VT_OP_NEIGHBOR_ALLTOALLW
      INTEGER VT_OP_INEIGHBOR_ALLTOALLW
      INTEGER VT_OP_REDUCE
      INTEGER VT_OP_REDUCE_LOCAL
      INTEGER VT_OP_IREDUCE
      INTEGER VT_OP_ALLREDUCE
      INTEGER VT_OP_IALLREDUCE
      INTEGER VT_OP_REDUCE_SCATTER
      INTEGER VT_OP_REDUCE_SCATTER_BLOCK
      INTEGER VT_OP_IREDUCE_SCATTER
      INTEGER VT_OP_IREDUCE_SCATTER_BLOCK
      INTEGER VT_OP_SCAN
      INTEGER VT_OP_ISCAN
      INTEGER VT_OP_EXSCAN
      INTEGER VT_OP_IEXSCAN
      INTEGER VT_OP_COUNT
      PARAMETER( VT_OP_INVALID=0 )
      PARAMETER( VT_OP_BARRIER=1 )
      PARAMETER( VT_OP_IBARRIER=2 )
      PARAMETER( VT_OP_BCAST=3 )
      PARAMETER( VT_OP_IBCAST=4 )
      PARAMETER( VT_OP_GATHER=5 )
      PARAMETER( VT_OP_IGATHER=6 )
      PARAMETER( VT_OP_GATHERV=7 )
      PARAMETER( VT_OP_IGATHERV=8 )
      PARAMETER( VT_OP_SCATTER=9 )
      PARAMETER( VT_OP_ISCATTER=10 )
      PARAMETER( VT_OP_SCATTERV=11 )
      PARAMETER( VT_OP_ISCATTERV=12 )
      PARAMETER( VT_OP_ALLGATHER=13 )
      PARAMETER( VT_OP_IALLGATHER=14 )
      PARAMETER( VT_OP_ALLGATHERV=15 )
      PARAMETER( VT_OP_IALLGATHERV=16 )
      PARAMETER( VT_OP_ALLTOALL=17 )
      PARAMETER( VT_OP_IALLTOALL=18 )
      PARAMETER( VT_OP_ALLTOALLV=19 )
      PARAMETER( VT_OP_IALLTOALLV=20 )
      PARAMETER( VT_OP_ALLTOALLW=21 )
      PARAMETER( VT_OP_IALLTOALLW=22 )
      PARAMETER( VT_OP_REDUCE=23 )
      PARAMETER( VT_OP_REDUCE_LOCAL=24 )
      PARAMETER( VT_OP_IREDUCE=25 )
      PARAMETER( VT_OP_ALLREDUCE=26 )
      PARAMETER( VT_OP_IALLREDUCE=27 )
      PARAMETER( VT_OP_REDUCE_SCATTER=28 )
      PARAMETER( VT_OP_REDUCE_SCATTER_BLOCK=29 )
      PARAMETER( VT_OP_IREDUCE_SCATTER=30 )
      PARAMETER( VT_OP_IREDUCE_SCATTER_BLOCK=31 )
      PARAMETER( VT_OP_SCAN=32 )
      PARAMETER( VT_OP_ISCAN=33 )
      PARAMETER( VT_OP_EXSCAN=34 )
      PARAMETER( VT_OP_IEXSCAN=35 )
      PARAMETER( VT_OP_COUNT=36 )

!-->  ITC API subroutines
      EXTERNAL VT_INIT
      EXTERNAL VT_FINI
      EXTERNAL VTVERSION
      INTEGER VTENABLED
      EXTERNAL VTENABLED
      EXTERNAL VTGETRANK
      EXTERNAL VTCOMMRANK
      EXTERNAL VTCOMMSIZE
      DOUBLE PRECISION VTSTAMP, VTTIMESTART, VTTIMEOFDAY
      EXTERNAL VTSTAMP
      EXTERNAL VTTIMESTART
      EXTERNAL VTTRACESTATE
      EXTERNAL VTSYMSTATE
      EXTERNAL VTTRACEON
      EXTERNAL VTTRACEOFF
      EXTERNAL VTFLUSH
      EXTERNAL VTSYMDEF
      EXTERNAL VTSYMDEFL
      EXTERNAL VTCLASSDEF
      EXTERNAL VTFUNCDEF
      EXTERNAL VTSCLDEF
      EXTERNAL VTBEGIN
      EXTERNAL VTEND
      EXTERNAL VTBEGINL
      EXTERNAL VTENDL
      EXTERNAL VTENTER
      EXTERNAL VTLEAVE
      EXTERNAL VTENDP
      EXTERNAL VTWAKEUP
      EXTERNAL VTSCOPEDEF
      EXTERNAL VTSCOPEBEGIN
      EXTERNAL VTSCOPEEND
      EXTERNAL VTPRUNE
      EXTERNAL VTTHISL
      EXTERNAL VTLOGSENDMSG
      EXTERNAL VTLOGRECVMSG
      EXTERNAL VTLOGOP
      EXTERNAL VTLOGCOMMENT
      EXTERNAL VTLOGOPEVENT
      EXTERNAL VTLOGMSGEVENT
      EXTERNAL VTBEGINUNORDERED
      EXTERNAL VTENDUNORDERED

!-->  ITC frame API subroutines
      INTEGER VT_CAT_ANY_DATA
      INTEGER VT_CAT_FUNCTIONS
      INTEGER VT_CAT_SCOPES
      INTEGER VT_CAT_OPENMP
      INTEGER VT_CAT_FILEIO
      INTEGER VT_CAT_COUNTERS
      INTEGER VT_CAT_MESSAGES
      INTEGER VT_CAT_COLLOPS
      PARAMETER (VT_CAT_ANY_DATA=0)
      PARAMETER (VT_CAT_FUNCTIONS=1)
      PARAMETER (VT_CAT_SCOPES=2)
      PARAMETER (VT_CAT_OPENMP=4)
      PARAMETER (VT_CAT_FILEIO=8)
      PARAMETER (VT_CAT_COUNTERS=16)
      PARAMETER (VT_CAT_MESSAGES=32)
      PARAMETER (VT_CAT_COLLOPS=64)
      INTEGER VT_FRAME_PROCESS
      INTEGER VT_FRAME_THREAD
      PARAMETER (VT_FRAME_PROCESS=0)
      PARAMETER (VT_FRAME_THREAD=1)
      EXTERNAL VTFRAMEDEF
      EXTERNAL VTFRAMEBEGIN
      EXTERNAL VTFRAMEEND
      EXTERNAL VTREGISTERTHREAD
      INTEGER VT_COUNT_INTEGER
      INTEGER VT_COUNT_FLOAT
      INTEGER VT_COUNT_DATA
      INTEGER VT_COUNT_ABSVAL
      INTEGER VT_COUNT_RATE
      INTEGER VT_COUNT_DISPLAY
      INTEGER VT_COUNT_VALID_BEFORE
      INTEGER VT_COUNT_VALID_POINT
      INTEGER VT_COUNT_VALID_AFTER
      INTEGER VT_COUNT_VALID_SAMPLE
      PARAMETER( VT_COUNT_INTEGER=0 )
      PARAMETER( VT_COUNT_FLOAT=1 )
      PARAMETER( VT_COUNT_DATA=15 )
      PARAMETER( VT_COUNT_ABSVAL=0 )
      PARAMETER( VT_COUNT_RATE=16 )
      PARAMETER( VT_COUNT_DISPLAY=240 )
      PARAMETER( VT_COUNT_VALID_BEFORE=0 )
      PARAMETER( VT_COUNT_VALID_POINT=256 )
      PARAMETER( VT_COUNT_VALID_AFTER=512 )
      PARAMETER( VT_COUNT_VALID_SAMPLE=768 )
      EXTERNAL VTCOUNTDEF
      EXTERNAL VTCOUNTVAL
      EXTERNAL VTCOUNTSTATE
      INTEGER VT_ME
      INTEGER VT_GROUP_THREAD
      INTEGER VT_GROUP_PROCESS
      INTEGER VT_GROUP_CLUSTER
      PARAMETER( VT_ME=-4 )
      PARAMETER( VT_GROUP_THREAD=-1 )
      PARAMETER( VT_GROUP_PROCESS=-2 )
      PARAMETER( VT_GROUP_CLUSTER=-3 )
      EXTERNAL VTGETTHREADID
      EXTERNAL VTGETPROCID
      EXTERNAL VTGROUPDEF
