 # INTEL_LICENSE_FILE:
if ( { test -n "/opt/intel/licenses:/root/intel/licenses" } ) then
    if ( $?INTEL_LICENSE_FILE ) then
        setenv INTEL_LICENSE_FILE "/opt/intel/licenses:/root/intel/licenses:${INTEL_LICENSE_FILE}"
    else
        setenv INTEL_LICENSE_FILE "/opt/intel/licenses:/root/intel/licenses"
    endif
endif

 # VT_ROOT:
setenv VT_ROOT "/opt/ohpc/pub/itac/9.1.2.024"

 # VT_ARCH:
setenv VT_ARCH "mic"

 # Temporary internal variable VT_ROOT_ARCH:
if ( { test -z "${VT_ARCH}" } ) then
    setenv VT_ROOT_ARCH "${VT_ROOT}"
else
    setenv VT_ROOT_ARCH "${VT_ROOT}/${VT_ARCH}"
endif

 # Check:
if ( ! -d "${VT_ROOT_ARCH}/lib" ) then
     # if only Intel(R) Trace Analyzer is installed:
    if ( -d "${VT_ROOT_ARCH}/bin" ) then
         # PATH:
        if ( $?PATH ) then
            setenv PATH "${VT_ROOT_ARCH}/bin:${PATH}"
        else
            setenv PATH "${VT_ROOT_ARCH}/bin"
        endif
        unsetenv VT_ROOT VT_ARCH VT_ROOT_ARCH
        exit 0
    endif
    echo "*** itacvars.csh: invalid VT_ROOT '${VT_ROOT}'" >&2
    unsetenv VT_ROOT VT_ARCH VT_ROOT_ARCH
    exit 1
endif

 # VT_LIB_DIR, VT_SLIB_DIR, VT_ADD_LIBS:
           setenv VT_MPI      "impi4"
           setenv VT_LIB_DIR  "${VT_ROOT_ARCH}/lib"
           setenv VT_SLIB_DIR "${VT_ROOT_ARCH}/slib"
           setenv VT_ADD_LIBS "-ldwarf -lelf -lvtunwind -lnsl -lm -ldl -lpthread"

 # Check:
if ( ! -d "${VT_LIB_DIR}" || ! -d "${VT_SLIB_DIR}" ) then
    echo "*** itacvars.csh: Library folders were not found. Installation may be incomplete." >&2
    unsetenv VT_ROOT VT_ARCH VT_ROOT_ARCH VT_MPI VT_LIB_DIR VT_SLIB_DIR VT_ADD_LIBS
    exit 1
endif

 # LD_LIBRARY_PATH:
if ( $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${VT_SLIB_DIR}:${LD_LIBRARY_PATH}"
else
    setenv LD_LIBRARY_PATH "${VT_SLIB_DIR}"
endif

 # PATH:
if ( $?PATH ) then
    setenv PATH "${VT_ROOT_ARCH}/bin:${PATH}"
else
    setenv PATH "${VT_ROOT_ARCH}/bin"
endif

 # MANPATH:
if ( $?MANPATH ) then
    setenv MANPATH "${VT_ROOT}/man:${MANPATH}"
else
    setenv MANPATH "${VT_ROOT}/man":`manpath`
endif

 # CLASSPATH:
if ( $?CLASSPATH ) then
    setenv CLASSPATH "${VT_LIB_DIR}:${CLASSPATH}"
else
    setenv CLASSPATH "${VT_LIB_DIR}"
endif

 # Unset temporary variables
unsetenv VT_ROOT_ARCH

# call mpsvars.sh as well with default settings i.e. nopapi
source ${VT_ROOT}/${VT_ARCH}/bin/mpsvars.csh --tooldir ${VT_ROOT}
